function measure {
    size=$1

    dim=$size
    proj=$size
    slices=400

    temp=100
    max_temp=50

    while [[ $temp -ge $max_temp ]]; do
	temp=$(nvidia-smi -q -d Temperature -i 1  | grep "Current" | cut -d ':' -f 2 | awk '{ print $1 }')
	if [[ $temp -ge $max_temp ]]; then
	    echo "Cooling down, currently $temp"
	    sleep 10
	fi
    done

    ./perf run --type perf --disable lprec,tomopy --params "num_slices=$slices num_projections=$proj width=$proj"
}



for size in `seq 128 128 4096`; do
    CUDA_VISIBLE_DEVICES=0 measure $size
    if [ $? -ne 0 ]; then
	echo "Error at size $size. Exiting..."
	echo
	exit -1
    fi
done
