__global__ void dfi_cuda_heatup_kernel(float seed, float *g_data) {
	int idx = blockIdx.x*blockDim.x + threadIdx.x;

	float  tmps[CUDA_HEATUP_ELEMENTS] = {0};
	for(int i = 0; i < CUDA_HEATUP_KERNEL_ITERATIONS; i++){	
#pragma unroll
		for(int j=0; j<CUDA_HEATUP_ELEMENTS; j++){
			tmps[j] = tmps[j]*tmps[j]+seed;
		}
	}
		// Multiply add reduction
	float sum = 0.f;
#pragma unroll
	for(int j=0; j<CUDA_HEATUP_ELEMENTS; j+=2)
		sum += tmps[j]*tmps[j+1];

	if ( sum == -1.f ) 
		g_data[idx] = sum;
}
